	TITLE	sieve.cc
_TEXT	SEGMENT	WORD PUBLIC 'CODE'
_TEXT	ENDS
_DATA	SEGMENT	WORD PUBLIC 'DATA'
_DATA	ENDS
CONST	SEGMENT	WORD PUBLIC 'CONST'
CONST	ENDS
CGROUP	GROUP	_TEXT
DGROUP	GROUP	_DATA,CONST
	ASSUME	DS:DGROUP, SS:DGROUP
	ASSUME	CS:CGROUP

_DATA	SEGMENT
	ALIGN	4
last	DD	0x0
_DATA	ENDS

CONST	SEGMENT
	ALIGN	4
$L01	DB	"%x",0aH,0H
CONST	ENDS

_DATA	SEGMENT
_DATA	ENDS

CONST	SEGMENT
	ALIGN	4
$L02	DB	"%d %d %g %g",0aH,0H
CONST	ENDS

_DATA	SEGMENT
_DATA	ENDS

CONST	SEGMENT
	ALIGN	4
$L03	DB	"   ======== Sieve of Eratosthenes Benchmark v1.4 ===="
	DB	"====",0aH,"Benchmarking in a %d KB block of memory (""
	DB	"./sieve N" changes this to N)",0aH,0H
	ALIGN	4
$L04	DB	"Timer resolution is %d us",0aH,0H
	ALIGN	4
$L05	DB	"DON'T FORGET TO RUN "full_power" SCRIPT AS A ROOT BEF"
	DB	"ORE TESTING ON LINUX!",0aH,0H
	ALIGN	4
$L06	DB	"# Compiled by Metaware High C R3.03",0aH,"# Benchmark"
	DB	"ing on a %d KB block with timer resolution of %d us.",0aH,0H
	ALIGN	4
$L07	DB	"#    size  slow_version [us] fast_version [us]  # of "
	DB	"inner iterations",0aH,0H
	ALIGN	4
$L08	DB	"%9u %17.3f %17.3f %17d",0aH,0H
	ALIGN	4
$L09	DB	"Progress: %d of %d = %5.2f%%, rep=%d ",0dH,0H
	ALIGN	4
$L010	DB	0aH,"Finished.",0aH,0H
CONST	ENDS

_DATA	SEGMENT
_DATA	ENDS

_TEXT	SEGMENT

;====================
; arr
;--------------------
	ALIGN	8
	PUBLIC	arr@qpucul$v
arr@qpucul$v	proc	near
	push	ebp
	mov	ebp,esp
	sub	esp,8
	push	edi
	push	esi
	push	ebx
	sub	esp,8
	sub	ebx,ebx
	cmp	ebx,DWORD PTR 12[ebp]
	jae	$L1
	mov	eax,DWORD PTR 12[ebp]
	add	eax,-4
	mov	DWORD PTR -8[ebp],eax
	mov	eax,DWORD PTR -8[ebp]
	xor	eax,DWORD PTR 12[ebp]
	xchg	eax,eax
	lea	edi,$L01
	mov	esi,DWORD PTR 8[ebp]
	jl	$L2
	mov	DWORD PTR -4[ebp],ebx
	cmp	ebx,DWORD PTR -8[ebp]
	jae	$L2
$L3:
	xor	eax,eax
	mov	al,BYTE PTR [esi,ebx]
	mov	DWORD PTR [esp],edi
	mov	DWORD PTR 4[esp],eax
	call	printf
	inc	ebx
	mov	DWORD PTR [esp],edi
	xor	eax,eax
	mov	al,BYTE PTR [esi,ebx]
	mov	DWORD PTR 4[esp],eax
	call	printf
	inc	ebx
	mov	DWORD PTR [esp],edi
	xor	eax,eax
	mov	al,BYTE PTR [esi,ebx]
	mov	DWORD PTR 4[esp],eax
	call	printf
	inc	ebx
	mov	DWORD PTR [esp],edi
	xor	eax,eax
	mov	al,BYTE PTR [esi,ebx]
	mov	DWORD PTR 4[esp],eax
	call	printf
	add	DWORD PTR -4[ebp],4
	inc	ebx
	mov	eax,DWORD PTR -8[ebp]
	cmp	DWORD PTR -4[ebp],eax
	jb	$L3
	mov	ebx,DWORD PTR -4[ebp]
$L2:
	xor	eax,eax
	mov	al,BYTE PTR [esi,ebx]
	mov	DWORD PTR [esp],edi
	mov	DWORD PTR 4[esp],eax
	call	printf
	inc	ebx
	cmp	ebx,DWORD PTR 12[ebp]
	jb	$L2
$L1:
	mov	esp,ebp
	mov	ebx,DWORD PTR -20[ebp]
	mov	esi,DWORD PTR -16[ebp]
	mov	edi,DWORD PTR -12[ebp]
	pop	ebp
	ret	
	ALIGN	8
arr@qpucul$v	ENDP
_TEXT	ENDS

CONST	SEGMENT
	ALIGN	4
$L011	DD	0x4f000000
CONST	ENDS

_TEXT	SEGMENT

;====================
; print_primes
;--------------------
	ALIGN	8
	PUBLIC	print_primes@qpucul$v
print_primes@qpucul$v	proc	near
	push	ebp
	mov	ebp,esp
	sub	esp,16
	mov	eax,DWORD PTR 12[ebp]
	push	edi
	push	esi
	push	ebx
	sub	esp,28
	shl	eax,3
	mov	esi,2
	mov	edi,1
	mov	DWORD PTR -12[ebp],eax
	cmp	esi,eax
	jae	$L4
	mov	eax,DWORD PTR -12[ebp]
	add	eax,-4
	mov	DWORD PTR -16[ebp],eax
	mov	eax,DWORD PTR -16[ebp]
	xor	eax,DWORD PTR -12[ebp]
	xchg	eax,eax
	mov	ebx,DWORD PTR 8[ebp]
	jl	$L5
	mov	DWORD PTR -8[ebp],esi
	cmp	esi,DWORD PTR -16[ebp]
	jae	$L5
$L6:
	mov	edx,esi
	shr	edx,3
	mov	ecx,esi
	and	ecx,7
	mov	eax,1
	shl	eax,cl
	test	BYTE PTR [ebx,edx],al
	jne	$L7
	mov	eax,esi
	mov	DWORD PTR [esp],OFFSET DGROUP:$L02
	sub	eax,-2147483648
	mov	DWORD PTR -4[ebp],eax
	fild	DWORD PTR -4[ebp]
	mov	eax,edi
	sub	eax,-2147483648
	fadd	DWORD PTR $L011
	mov	DWORD PTR 4[esp],esi
	mov	DWORD PTR 8[esp],edi
	xchg	eax,eax
	mov	DWORD PTR -4[ebp],eax
	fldln2	
	fld	st(1)
	fyl2x	
	fdivrp	st(1),st
	fild	DWORD PTR -4[ebp]
	fadd	DWORD PTR $L011
	fdivr	st,st(1)
	fxch	st(1)
	fstp	QWORD PTR 12[esp]
	fstp	QWORD PTR 20[esp]
	call	printf
	inc	edi
$L7:
	inc	esi
	mov	edx,esi
	shr	edx,3
	mov	ecx,esi
	and	ecx,7
	mov	eax,1
	shl	eax,cl
	test	BYTE PTR [ebx,edx],al
	jne	$L8
	mov	eax,esi
	mov	DWORD PTR [esp],OFFSET DGROUP:$L02
	sub	eax,-2147483648
	mov	DWORD PTR -4[ebp],eax
	fild	DWORD PTR -4[ebp]
	mov	eax,edi
	sub	eax,-2147483648
	fadd	DWORD PTR $L011
	mov	DWORD PTR 4[esp],esi
	mov	DWORD PTR 8[esp],edi
	xchg	eax,eax
	mov	DWORD PTR -4[ebp],eax
	fldln2	
	fld	st(1)
	fyl2x	
	fdivrp	st(1),st
	fild	DWORD PTR -4[ebp]
	fadd	DWORD PTR $L011
	fdivr	st,st(1)
	fxch	st(1)
	fstp	QWORD PTR 12[esp]
	fstp	QWORD PTR 20[esp]
	call	printf
	inc	edi
$L8:
	inc	esi
	mov	edx,esi
	shr	edx,3
	mov	ecx,esi
	and	ecx,7
	mov	eax,1
	shl	eax,cl
	test	BYTE PTR [ebx,edx],al
	jne	$L9
	mov	eax,esi
	mov	DWORD PTR [esp],OFFSET DGROUP:$L02
	sub	eax,-2147483648
	mov	DWORD PTR -4[ebp],eax
	fild	DWORD PTR -4[ebp]
	mov	eax,edi
	sub	eax,-2147483648
	fadd	DWORD PTR $L011
	mov	DWORD PTR 4[esp],esi
	mov	DWORD PTR 8[esp],edi
	xchg	eax,eax
	mov	DWORD PTR -4[ebp],eax
	fldln2	
	fld	st(1)
	fyl2x	
	fdivrp	st(1),st
	fild	DWORD PTR -4[ebp]
	fadd	DWORD PTR $L011
	fdivr	st,st(1)
	fxch	st(1)
	fstp	QWORD PTR 12[esp]
	fstp	QWORD PTR 20[esp]
	call	printf
	inc	edi
$L9:
	inc	esi
	mov	edx,esi
	shr	edx,3
	mov	ecx,esi
	and	ecx,7
	mov	eax,1
	shl	eax,cl
	test	BYTE PTR [ebx,edx],al
	jne	$L10
	mov	eax,esi
	mov	DWORD PTR [esp],OFFSET DGROUP:$L02
	sub	eax,-2147483648
	mov	DWORD PTR -4[ebp],eax
	fild	DWORD PTR -4[ebp]
	mov	eax,edi
	sub	eax,-2147483648
	fadd	DWORD PTR $L011
	mov	DWORD PTR 4[esp],esi
	mov	DWORD PTR 8[esp],edi
	xchg	eax,eax
	mov	DWORD PTR -4[ebp],eax
	fldln2	
	fld	st(1)
	fyl2x	
	fdivrp	st(1),st
	fild	DWORD PTR -4[ebp]
	fadd	DWORD PTR $L011
	fdivr	st,st(1)
	fxch	st(1)
	fstp	QWORD PTR 12[esp]
	fstp	QWORD PTR 20[esp]
	call	printf
	inc	edi
$L10:
	add	DWORD PTR -8[ebp],4
	inc	esi
	mov	eax,DWORD PTR -16[ebp]
	cmp	DWORD PTR -8[ebp],eax
	jb	$L6
	mov	esi,DWORD PTR -8[ebp]
$L5:
	mov	edx,esi
	shr	edx,3
	mov	ecx,esi
	and	ecx,7
	mov	eax,1
	shl	eax,cl
	test	BYTE PTR [ebx,edx],al
	jne	$L11
	mov	eax,esi
	mov	DWORD PTR [esp],OFFSET DGROUP:$L02
	sub	eax,-2147483648
	mov	DWORD PTR -4[ebp],eax
	fild	DWORD PTR -4[ebp]
	mov	eax,edi
	sub	eax,-2147483648
	fadd	DWORD PTR $L011
	mov	DWORD PTR 4[esp],esi
	mov	DWORD PTR 8[esp],edi
	xchg	eax,eax
	mov	DWORD PTR -4[ebp],eax
	fldln2	
	fld	st(1)
	fyl2x	
	fdivrp	st(1),st
	fild	DWORD PTR -4[ebp]
	fadd	DWORD PTR $L011
	fdivr	st,st(1)
	fxch	st(1)
	fstp	QWORD PTR 12[esp]
	fstp	QWORD PTR 20[esp]
	call	printf
	inc	edi
$L11:
	inc	esi
	cmp	esi,DWORD PTR -12[ebp]
	jb	$L5
$L4:
	mov	esp,ebp
	mov	ebx,DWORD PTR -28[ebp]
	mov	esi,DWORD PTR -24[ebp]
	mov	edi,DWORD PTR -20[ebp]
	pop	ebp
	ret	
	ALIGN	8
print_primes@qpucul$v	ENDP

;====================
; ct_sieve
;--------------------
	ALIGN	8
	PUBLIC	ct_sieve@qpucul$ul
ct_sieve@qpucul$ul	proc	near
	push	ebp
	mov	ebp,esp
	sub	esp,12
	mov	ecx,DWORD PTR 12[ebp]
	mov	eax,ecx
	shl	eax,3
	push	edi
	push	esi
	mov	DWORD PTR -12[ebp],eax
	sub	edi,edi
	push	ebx
	mov	al,85
	push	edi
	mov	ah,al
	push	ax
	shl	eax,16
	shrd	edx,ecx,2
	shr	ecx,2
	mov	esi,DWORD PTR 8[ebp]
	mov	ebx,9
	mov	edi,esi
	pop	ax
	rep		stos	
	shld	ecx,edx,2
	rep		stos	
	mov	BYTE PTR [esi],83
	mov	DWORD PTR -4[ebp],3
	cmp	ebx,DWORD PTR -12[ebp]
	pop	edi
	jae	$L12
$L13:
	mov	ecx,DWORD PTR -4[ebp]
	mov	edx,ecx
	shr	edx,3
	and	ecx,7
	mov	eax,1
	shl	eax,cl
	test	BYTE PTR [esi,edx],al
	jne	$L14
	mov	edx,DWORD PTR -4[ebp]
	shl	edx,1
	cmp	edx,DWORD PTR -12[ebp]
	jae	$L14
$L15:
	mov	ebx,edx
	shr	ebx,3
	mov	ecx,edx
	and	ecx,7
	add	edx,DWORD PTR -4[ebp]
	mov	eax,1
	shl	eax,cl
	mov	DWORD PTR -8[ebp],edi
	inc	edi
	or	BYTE PTR [esi,ebx],al
	cmp	edx,DWORD PTR -12[ebp]
	jb	$L16
$L14:
	inc	DWORD PTR -4[ebp]
	mov	eax,DWORD PTR -4[ebp]
	imul	eax,eax
	cmp	eax,DWORD PTR -12[ebp]
	jb	$L13
$L12:
	pop	ebx
	pop	esi
	mov	eax,edi
	pop	edi
	mov	esp,ebp
	pop	ebp
	ret	
	ALIGN	8
$L16:
	mov	ebx,edx
	shr	ebx,3
	mov	ecx,edx
	and	ecx,7
	add	edx,DWORD PTR -4[ebp]
	mov	eax,1
	shl	eax,cl
	mov	edi,DWORD PTR -8[ebp]
	add	edi,2
	or	BYTE PTR [esi,ebx],al
	cmp	edx,DWORD PTR -12[ebp]
	jae	$L14
	mov	ebx,edx
	shr	ebx,3
	mov	ecx,edx
	and	ecx,7
	add	edx,DWORD PTR -4[ebp]
	mov	eax,1
	shl	eax,cl
	mov	edi,DWORD PTR -8[ebp]
	add	edi,3
	or	BYTE PTR [esi,ebx],al
	cmp	edx,DWORD PTR -12[ebp]
	jae	$L14
	mov	ebx,edx
	shr	ebx,3
	mov	ecx,edx
	and	ecx,7
	add	edx,DWORD PTR -4[ebp]
	mov	eax,1
	shl	eax,cl
	mov	edi,DWORD PTR -8[ebp]
	add	edi,4
	or	BYTE PTR [esi,ebx],al
	cmp	edx,DWORD PTR -12[ebp]
	jb	$L15
	jmp	$L14
	ALIGN	8
ct_sieve@qpucul$ul	ENDP

;====================
; sieve
;--------------------
	ALIGN	8
	PUBLIC	sieve@qpucul$v
sieve@qpucul$v	proc	near
	push	ebp
	mov	ebp,esp
	sub	esp,4
	mov	ecx,DWORD PTR 12[ebp]
	mov	eax,ecx
	shl	eax,3
	push	edi
	mov	DWORD PTR -4[ebp],eax
	push	esi
	mov	al,85
	push	ebx
	mov	ah,al
	push	ax
	shl	eax,16
	shrd	edx,ecx,2
	shr	ecx,2
	mov	esi,DWORD PTR 8[ebp]
	mov	ebx,9
	mov	edi,esi
	pop	ax
	rep		stos	
	shld	ecx,edx,2
	rep		stos	
	mov	BYTE PTR [esi],83
	mov	edi,3
	cmp	ebx,DWORD PTR -4[ebp]
	jae	$L17
$L18:
	mov	edx,edi
	shr	edx,3
	mov	ecx,edi
	and	ecx,7
	mov	eax,1
	shl	eax,cl
	test	BYTE PTR [esi,edx],al
	jne	$L19
	mov	edx,edi
	shl	edx,1
	cmp	edx,DWORD PTR -4[ebp]
	jae	$L19
$L20:
	mov	ebx,edx
	shr	ebx,3
	mov	ecx,edx
	and	ecx,7
	add	edx,edi
	mov	eax,1
	shl	eax,cl
	or	BYTE PTR [esi,ebx],al
	cmp	edx,DWORD PTR -4[ebp]
	jb	$L21
$L19:
	inc	edi
	mov	eax,edi
	imul	eax,edi
	cmp	eax,DWORD PTR -4[ebp]
	jb	$L18
$L17:
	pop	ebx
	pop	esi
	pop	edi
	mov	esp,ebp
	pop	ebp
	ret	
	ALIGN	8
$L21:
	mov	ebx,edx
	shr	ebx,3
	mov	ecx,edx
	and	ecx,7
	add	edx,edi
	mov	eax,1
	shl	eax,cl
	or	BYTE PTR [esi,ebx],al
	cmp	edx,DWORD PTR -4[ebp]
	jae	$L19
	mov	ebx,edx
	shr	ebx,3
	mov	ecx,edx
	and	ecx,7
	add	edx,edi
	mov	eax,1
	shl	eax,cl
	or	BYTE PTR [esi,ebx],al
	cmp	edx,DWORD PTR -4[ebp]
	jae	$L19
	mov	ebx,edx
	shr	ebx,3
	mov	ecx,edx
	and	ecx,7
	add	edx,edi
	mov	eax,1
	shl	eax,cl
	or	BYTE PTR [esi,ebx],al
	cmp	edx,DWORD PTR -4[ebp]
	jb	$L20
	jmp	$L19
	ALIGN	8
sieve@qpucul$v	ENDP

;====================
; fast_sieve
;--------------------
	ALIGN	8
	PUBLIC	fast_sieve@qpucul$v
fast_sieve@qpucul$v	proc	near
	push	ebp
	mov	ebp,esp
	sub	esp,12
	mov	ecx,DWORD PTR 12[ebp]
	mov	eax,ecx
	shl	eax,3
	push	edi
	mov	DWORD PTR -12[ebp],eax
	push	esi
	mov	al,85
	push	ebx
	mov	edi,DWORD PTR 8[ebp]
	mov	ah,al
	mov	esi,DWORD PTR 8[ebp]
	add	esi,ecx
	push	edi
	push	ax
	shl	eax,16
	shrd	edx,ecx,2
	shr	ecx,2
	mov	DWORD PTR -8[ebp],9
	pop	ax
	rep		stos	
	shld	ecx,edx,2
	rep		stos	
	pop	edi
	mov	ecx,edi
	mov	edi,3
	mov	BYTE PTR [ecx],83
	mov	eax,DWORD PTR -12[ebp]
	cmp	DWORD PTR -8[ebp],eax
	jae	$L22
$L23:
	mov	edx,edi
	shr	edx,3
	mov	ecx,edi
	and	ecx,7
	mov	eax,1
	shl	eax,cl
	mov	ecx,DWORD PTR 8[ebp]
	test	BYTE PTR [ecx,edx],al
	je	$L24
	mov	eax,edi
	shl	eax,1
	mov	DWORD PTR -4[ebp],eax
	jmp	$L25
	ALIGN	8
$L24:
	mov	eax,edi
	shl	eax,1
	mov	DWORD PTR -4[ebp],eax
	sub	eax,DWORD PTR -12[ebp]
	jge	$L25
$L26:
	mov	ebx,eax
	sar	ebx,3
	mov	ecx,eax
	and	ecx,7
	add	eax,edi
	mov	edx,1
	shl	edx,cl
	or	BYTE PTR [esi,ebx],dl
	and	eax,eax
	jl	$L27
$L25:
	mov	eax,DWORD PTR -4[ebp]
	inc	eax
	inc	edi
	add	eax,DWORD PTR -8[ebp]
	mov	DWORD PTR -8[ebp],eax
	cmp	eax,DWORD PTR -12[ebp]
	jb	$L23
$L22:
	pop	ebx
	pop	esi
	pop	edi
	mov	esp,ebp
	pop	ebp
	ret	
	ALIGN	8
$L27:
	mov	ebx,eax
	sar	ebx,3
	mov	ecx,eax
	and	ecx,7
	add	eax,edi
	mov	edx,1
	shl	edx,cl
	or	BYTE PTR [esi,ebx],dl
	and	eax,eax
	jge	$L25
	mov	ebx,eax
	sar	ebx,3
	mov	ecx,eax
	and	ecx,7
	add	eax,edi
	mov	edx,1
	shl	edx,cl
	or	BYTE PTR [esi,ebx],dl
	and	eax,eax
	jge	$L25
	mov	ebx,eax
	sar	ebx,3
	mov	ecx,eax
	and	ecx,7
	add	eax,edi
	mov	edx,1
	shl	edx,cl
	or	BYTE PTR [esi,ebx],dl
	and	eax,eax
	jl	$L26
	jmp	$L25
	ALIGN	8
fast_sieve@qpucul$v	ENDP
_TEXT	ENDS

CONST	SEGMENT
	ALIGN	4
$L012	DD	0x78b58c40,0x4415af1d	; 1.0e20
	ALIGN	4
$L013	DD	0x0,0x40590000	; 1.0e2
CONST	ENDS

_TEXT	SEGMENT

;====================
; measure
;--------------------
	ALIGN	8
	PUBLIC	measure@qui$v
measure@qui$v	proc	near
	push	ebp
	mov	ebp,esp
	sub	esp,164
	push	edi
	push	esi
	push	ebx
	sub	esp,28
$L28:
	mov	eax,DWORD PTR 8[ebp]
	mov	DWORD PTR [esp],eax
	call	malloc
	mov	DWORD PTR -44[ebp],eax
	cmp	DWORD PTR -44[ebp],0
	jne	$L29
	mov	eax,DWORD PTR 8[ebp]
	shr	eax,1
	mov	DWORD PTR 8[ebp],eax
	mov	DWORD PTR [esp],eax
	call	malloc
	mov	DWORD PTR -44[ebp],eax
	and	eax,eax
	jne	$L29
	mov	eax,DWORD PTR 8[ebp]
	shr	eax,1
	mov	DWORD PTR 8[ebp],eax
	mov	DWORD PTR [esp],eax
	call	malloc
	mov	DWORD PTR -44[ebp],eax
	and	eax,eax
	jne	$L29
	mov	eax,DWORD PTR 8[ebp]
	shr	eax,1
	mov	DWORD PTR 8[ebp],eax
	mov	DWORD PTR [esp],eax
	call	malloc
	mov	DWORD PTR -44[ebp],eax
	and	eax,eax
	jne	$L29
	mov	eax,DWORD PTR 8[ebp]
	shr	eax,1
	mov	DWORD PTR 8[ebp],eax
	jmp	$L28
	ALIGN	8
$L29:
	sub	eax,eax
	mov	ecx,DWORD PTR 8[ebp]
	mov	edx,DWORD PTR 8[ebp]
	shr	edx,10
	mov	ah,al
	mov	esi,DWORD PTR -44[ebp]
	push	ax
	shl	eax,16
	mov	DWORD PTR -80[ebp],edx
	shrd	edx,ecx,2
	shr	ecx,2
	mov	edi,esi
	pop	ax
	rep		stos	
	shld	ecx,edx,2
	rep		stos	
	mov	DWORD PTR [esp],OFFSET DGROUP:_iob+40
	mov	DWORD PTR 4[esp],OFFSET DGROUP:$L03
	mov	eax,DWORD PTR -80[ebp]
	xchg	eax,eax
	mov	DWORD PTR 8[esp],eax
	call	fprintf
	mov	DWORD PTR -72[ebp],-2147483648
	mov	DWORD PTR -76[ebp],5
	lea	esi,-152[ebp]
$L30:
	xchg	eax,eax
	lea	eax,-164[ebp]
	mov	DWORD PTR [esp],eax
	call	ftime
	mov	edi,DWORD PTR -164[ebp]
	mov	ebx,edi
	shl	ebx,4
	xor	edx,edx
	mov	dx,WORD PTR -160[ebp]
	sub	ebx,edi
	mov	eax,edx
	shl	eax,5
	lea	ebx,[edi,ebx*4]
	shl	ebx,5
	sub	eax,edx
	lea	eax,[edx,eax*4]
	add	ebx,edi
	lea	edx,[edi,ebx*8]
	shl	edx,6
	mov	ecx,DWORD PTR last
	lea	eax,[edx,eax*8]
	mov	edx,eax
	sub	edx,ecx
	jge	$L31
	sub	ecx,eax
	cmp	ecx,1073741824
	jb	$L32
$L31:
	mov	DWORD PTR last,eax
	mov	DWORD PTR -60[ebp],eax
$L33:
	mov	DWORD PTR [esp],esi
	call	ftime
	mov	edx,DWORD PTR -152[ebp]
	mov	ebx,edx
	shl	ebx,4
	xor	edi,edi
	mov	di,WORD PTR -148[ebp]
	sub	ebx,edx
	mov	eax,edi
	shl	eax,5
	lea	ebx,[edx,ebx*4]
	shl	ebx,5
	sub	eax,edi
	add	ebx,edx
	lea	edx,[edx,ebx*8]
	shl	edx,6
	lea	eax,[edi,eax*4]
	lea	eax,[edx,eax*8]
	mov	ecx,DWORD PTR last
	mov	edx,eax
	sub	edx,ecx
	jge	$L34
	sub	ecx,eax
	cmp	ecx,1073741824
	jb	$L35
$L34:
	mov	DWORD PTR last,eax
	cmp	eax,DWORD PTR -60[ebp]
	je	$L33
	mov	ecx,eax
	sub	ecx,DWORD PTR -60[ebp]
	mov	eax,DWORD PTR -72[ebp]
	cmp	eax,ecx
	jb	$L36
	mov	eax,ecx
$L36:
	dec	DWORD PTR -76[ebp]
	mov	DWORD PTR -72[ebp],eax
	cmp	DWORD PTR -76[ebp],0
	jge	$L30
	mov	DWORD PTR [esp],OFFSET DGROUP:_iob+40
	mov	DWORD PTR 4[esp],OFFSET DGROUP:$L04
	mov	DWORD PTR 8[esp],eax
	call	fprintf
	mov	DWORD PTR [esp],OFFSET DGROUP:_iob+40
	mov	DWORD PTR 4[esp],OFFSET DGROUP:$L05
	call	fprintf
	mov	DWORD PTR [esp],OFFSET DGROUP:_iob+40
	call	fflush
	mov	DWORD PTR [esp],OFFSET DGROUP:$L06
	mov	eax,DWORD PTR -80[ebp]
	mov	DWORD PTR 4[esp],eax
	xchg	eax,eax
	mov	eax,DWORD PTR -72[ebp]
	mov	DWORD PTR 8[esp],eax
	call	printf
	mov	DWORD PTR [esp],OFFSET DGROUP:$L07
	call	printf
	mov	esi,30
	cmp	esi,DWORD PTR 8[ebp]
	ja	$L37
	mov	eax,DWORD PTR 8[ebp]
	sub	eax,-2147483648
	mov	DWORD PTR -4[ebp],eax
	fild	DWORD PTR -4[ebp]
	fadd	DWORD PTR $L011
	xchg	eax,eax
	fstp	QWORD PTR -20[ebp]
$L38:
	fld	QWORD PTR $L012
	mov	DWORD PTR -56[ebp],0
	fst	QWORD PTR -36[ebp]
	xchg	eax,eax
	fstp	QWORD PTR -12[ebp]
	mov	DWORD PTR -68[ebp],1
$L39:
	lea	eax,-140[ebp]
	mov	DWORD PTR [esp],eax
	call	ftime
	mov	edi,DWORD PTR -140[ebp]
	mov	eax,edi
	shl	eax,4
	xor	edx,edx
	mov	dx,WORD PTR -136[ebp]
	sub	eax,edi
	mov	ebx,edx
	shl	ebx,5
	lea	eax,[edi,eax*4]
	shl	eax,5
	sub	ebx,edx
	add	eax,edi
	lea	eax,[edi,eax*8]
	shl	eax,6
	lea	edx,[edx,ebx*4]
	lea	eax,[eax,edx*8]
	mov	ecx,DWORD PTR last
	mov	edx,eax
	sub	edx,ecx
	jge	$L40
	sub	ecx,eax
	cmp	ecx,1073741824
	jb	$L41
$L40:
	mov	DWORD PTR last,eax
	mov	DWORD PTR -64[ebp],eax
	cmp	DWORD PTR -68[ebp],1
	jne	$L42
	mov	eax,DWORD PTR -72[ebp]
	shl	eax,8
	mov	DWORD PTR -52[ebp],eax
$L43:
	lea	eax,-128[ebp]
	mov	DWORD PTR [esp],eax
	call	ftime
	mov	edi,DWORD PTR -128[ebp]
	mov	eax,edi
	shl	eax,4
	xor	edx,edx
	mov	dx,WORD PTR -124[ebp]
	sub	eax,edi
	mov	ebx,edx
	shl	ebx,5
	lea	eax,[edi,eax*4]
	shl	eax,5
	sub	ebx,edx
	add	eax,edi
	lea	eax,[edi,eax*8]
	shl	eax,6
	lea	edx,[edx,ebx*4]
	lea	eax,[eax,edx*8]
	mov	ecx,DWORD PTR last
	mov	edx,eax
	sub	edx,ecx
	jge	$L44
	sub	ecx,eax
	cmp	ecx,1073741824
	jb	$L45
$L44:
	mov	DWORD PTR last,eax
	sub	eax,DWORD PTR -64[ebp]
	cmp	eax,DWORD PTR -52[ebp]
	jae	$L46
$L47:
	mov	eax,DWORD PTR -44[ebp]
	mov	DWORD PTR [esp],eax
	mov	DWORD PTR 4[esp],esi
	call	sieve@qpucul$v
	inc	DWORD PTR -56[ebp]
$L48:
	lea	eax,-116[ebp]
	mov	DWORD PTR [esp],eax
	call	ftime
	mov	edi,DWORD PTR -116[ebp]
	mov	eax,edi
	shl	eax,4
	xor	edx,edx
	mov	dx,WORD PTR -112[ebp]
	sub	eax,edi
	mov	ebx,edx
	shl	ebx,5
	lea	eax,[edi,eax*4]
	shl	eax,5
	sub	ebx,edx
	add	eax,edi
	lea	eax,[edi,eax*8]
	shl	eax,6
	lea	edx,[edx,ebx*4]
	lea	eax,[eax,edx*8]
	mov	ecx,DWORD PTR last
	mov	edx,eax
	sub	edx,ecx
	jge	$L49
	sub	ecx,eax
	cmp	ecx,1073741824
	jb	$L50
$L49:
	mov	DWORD PTR last,eax
	sub	eax,DWORD PTR -64[ebp]
	cmp	eax,DWORD PTR -52[ebp]
	jb	$L47
$L46:
	mov	ecx,DWORD PTR -56[ebp]
	mov	eax,DWORD PTR -56[ebp]
	dec	ecx
	mov	DWORD PTR -40[ebp],ecx
	sub	eax,-2147483648
	mov	DWORD PTR -4[ebp],eax
	fild	DWORD PTR -4[ebp]
	fadd	DWORD PTR $L011
	xchg	eax,eax
	fstp	QWORD PTR -28[ebp]
	jmp	$L51
	ALIGN	8
$L32:
	lea	eax,-164[ebp]
	mov	DWORD PTR [esp],eax
	call	ftime
	mov	edi,DWORD PTR -164[ebp]
	mov	ebx,edi
	shl	ebx,4
	xor	edx,edx
	mov	dx,WORD PTR -160[ebp]
	sub	ebx,edi
	mov	eax,edx
	shl	eax,5
	lea	ebx,[edi,ebx*4]
	shl	ebx,5
	sub	eax,edx
	lea	eax,[edx,eax*4]
	add	ebx,edi
	lea	edx,[edi,ebx*8]
	shl	edx,6
	mov	ecx,DWORD PTR last
	lea	eax,[edx,eax*8]
	mov	edx,eax
	sub	edx,ecx
	jge	$L31
	sub	ecx,eax
	cmp	ecx,1073741824
	jae	$L31
	lea	eax,-164[ebp]
	mov	DWORD PTR [esp],eax
	call	ftime
	mov	edi,DWORD PTR -164[ebp]
	mov	eax,edi
	shl	eax,4
	xor	edx,edx
	mov	dx,WORD PTR -160[ebp]
	sub	eax,edi
	mov	ebx,edx
	shl	ebx,5
	lea	eax,[edi,eax*4]
	shl	eax,5
	sub	ebx,edx
	add	eax,edi
	lea	eax,[edi,eax*8]
	shl	eax,6
	lea	edx,[edx,ebx*4]
	lea	eax,[eax,edx*8]
	mov	ecx,DWORD PTR last
	mov	edx,eax
	sub	edx,ecx
	jge	$L31
	sub	ecx,eax
	cmp	ecx,1073741824
	jae	$L31
	lea	eax,-164[ebp]
	mov	DWORD PTR [esp],eax
	call	ftime
	mov	edx,DWORD PTR -164[ebp]
	mov	ebx,edx
	shl	ebx,4
	xor	edi,edi
	mov	di,WORD PTR -160[ebp]
	sub	ebx,edx
	mov	eax,edi
	shl	eax,5
	lea	ebx,[edx,ebx*4]
	shl	ebx,5
	sub	eax,edi
	add	ebx,edx
	lea	edx,[edx,ebx*8]
	shl	edx,6
	lea	eax,[edi,eax*4]
	lea	eax,[edx,eax*8]
	mov	ecx,DWORD PTR last
	mov	edx,eax
	sub	edx,ecx
	jge	$L31
	sub	ecx,eax
	cmp	ecx,1073741824
	jb	$L30
	jmp	$L31
	ALIGN	8
$L35:
	mov	DWORD PTR [esp],esi
	call	ftime
	mov	edi,DWORD PTR -152[ebp]
	mov	ebx,edi
	shl	ebx,4
	xor	edx,edx
	mov	dx,WORD PTR -148[ebp]
	sub	ebx,edi
	mov	eax,edx
	shl	eax,5
	lea	ebx,[edi,ebx*4]
	shl	ebx,5
	sub	eax,edx
	lea	eax,[edx,eax*4]
	add	ebx,edi
	lea	edx,[edi,ebx*8]
	shl	edx,6
	mov	ecx,DWORD PTR last
	lea	eax,[edx,eax*8]
	mov	edx,eax
	sub	edx,ecx
	jge	$L34
	sub	ecx,eax
	cmp	ecx,1073741824
	jae	$L34
	mov	DWORD PTR [esp],esi
	call	ftime
	mov	edi,DWORD PTR -152[ebp]
	mov	eax,edi
	shl	eax,4
	xor	edx,edx
	mov	dx,WORD PTR -148[ebp]
	sub	eax,edi
	mov	ebx,edx
	shl	ebx,5
	lea	eax,[edi,eax*4]
	shl	eax,5
	sub	ebx,edx
	add	eax,edi
	lea	eax,[edi,eax*8]
	shl	eax,6
	lea	edx,[edx,ebx*4]
	lea	eax,[eax,edx*8]
	mov	ecx,DWORD PTR last
	mov	edx,eax
	sub	edx,ecx
	jge	$L34
	sub	ecx,eax
	cmp	ecx,1073741824
	jae	$L34
	mov	DWORD PTR [esp],esi
	call	ftime
	mov	edx,DWORD PTR -152[ebp]
	mov	ebx,edx
	shl	ebx,4
	xor	edi,edi
	mov	di,WORD PTR -148[ebp]
	sub	ebx,edx
	mov	eax,edi
	shl	eax,5
	lea	ebx,[edx,ebx*4]
	shl	ebx,5
	sub	eax,edi
	add	ebx,edx
	lea	edx,[edx,ebx*8]
	shl	edx,6
	lea	eax,[edi,eax*4]
	lea	eax,[edx,eax*8]
	mov	ecx,DWORD PTR last
	mov	edx,eax
	sub	edx,ecx
	jge	$L34
	sub	ecx,eax
	cmp	ecx,1073741824
	jb	$L33
	jmp	$L34
	ALIGN	8
$L41:
	lea	eax,-140[ebp]
	mov	DWORD PTR [esp],eax
	call	ftime
	mov	edx,DWORD PTR -140[ebp]
	mov	ebx,edx
	shl	ebx,4
	xor	edi,edi
	mov	di,WORD PTR -136[ebp]
	sub	ebx,edx
	mov	eax,edi
	shl	eax,5
	lea	ebx,[edx,ebx*4]
	shl	ebx,5
	sub	eax,edi
	add	ebx,edx
	lea	edx,[edx,ebx*8]
	shl	edx,6
	lea	eax,[edi,eax*4]
	lea	eax,[edx,eax*8]
	mov	ecx,DWORD PTR last
	mov	edx,eax
	sub	edx,ecx
	jge	$L40
	sub	ecx,eax
	cmp	ecx,1073741824
	jae	$L40
	lea	eax,-140[ebp]
	mov	DWORD PTR [esp],eax
	call	ftime
	mov	edx,DWORD PTR -140[ebp]
	mov	eax,edx
	shl	eax,4
	xor	edi,edi
	mov	di,WORD PTR -136[ebp]
	sub	eax,edx
	mov	ebx,edi
	shl	ebx,5
	lea	eax,[edx,eax*4]
	shl	eax,5
	sub	ebx,edi
	add	eax,edx
	lea	eax,[edx,eax*8]
	shl	eax,6
	lea	edi,[edi,ebx*4]
	lea	eax,[eax,edi*8]
	mov	ecx,DWORD PTR last
	mov	edx,eax
	sub	edx,ecx
	jge	$L40
	sub	ecx,eax
	cmp	ecx,1073741824
	jae	$L40
	lea	eax,-140[ebp]
	mov	DWORD PTR [esp],eax
	call	ftime
	mov	edi,DWORD PTR -140[ebp]
	mov	ebx,edi
	shl	ebx,4
	xor	edx,edx
	mov	dx,WORD PTR -136[ebp]
	sub	ebx,edi
	mov	eax,edx
	shl	eax,5
	lea	ebx,[edi,ebx*4]
	shl	ebx,5
	sub	eax,edx
	lea	eax,[edx,eax*4]
	add	ebx,edi
	lea	edx,[edi,ebx*8]
	shl	edx,6
	mov	ecx,DWORD PTR last
	lea	eax,[edx,eax*8]
	mov	edx,eax
	sub	edx,ecx
	jge	$L40
	sub	ecx,eax
	cmp	ecx,1073741824
	jb	$L39
	jmp	$L40
	ALIGN	8
$L45:
	lea	eax,-128[ebp]
	mov	DWORD PTR [esp],eax
	call	ftime
	mov	edx,DWORD PTR -128[ebp]
	mov	eax,edx
	shl	eax,4
	xor	edi,edi
	mov	di,WORD PTR -124[ebp]
	sub	eax,edx
	mov	ebx,edi
	shl	ebx,5
	lea	eax,[edx,eax*4]
	shl	eax,5
	sub	ebx,edi
	add	eax,edx
	lea	eax,[edx,eax*8]
	shl	eax,6
	lea	edi,[edi,ebx*4]
	lea	eax,[eax,edi*8]
	mov	ecx,DWORD PTR last
	mov	edx,eax
	sub	edx,ecx
	jge	$L44
	sub	ecx,eax
	cmp	ecx,1073741824
	jae	$L44
	lea	eax,-128[ebp]
	mov	DWORD PTR [esp],eax
	call	ftime
	mov	edx,DWORD PTR -128[ebp]
	mov	ebx,edx
	shl	ebx,4
	xor	edi,edi
	mov	di,WORD PTR -124[ebp]
	sub	ebx,edx
	mov	eax,edi
	shl	eax,5
	lea	ebx,[edx,ebx*4]
	shl	ebx,5
	sub	eax,edi
	add	ebx,edx
	lea	edx,[edx,ebx*8]
	shl	edx,6
	lea	eax,[edi,eax*4]
	lea	eax,[edx,eax*8]
	mov	ecx,DWORD PTR last
	mov	edx,eax
	sub	edx,ecx
	jge	$L44
	sub	ecx,eax
	cmp	ecx,1073741824
	jae	$L44
	lea	eax,-128[ebp]
	mov	DWORD PTR [esp],eax
	call	ftime
	mov	edx,DWORD PTR -128[ebp]
	mov	ebx,edx
	shl	ebx,4
	xor	edi,edi
	mov	di,WORD PTR -124[ebp]
	sub	ebx,edx
	mov	eax,edi
	shl	eax,5
	lea	ebx,[edx,ebx*4]
	shl	ebx,5
	sub	eax,edi
	add	ebx,edx
	lea	edx,[edx,ebx*8]
	shl	edx,6
	lea	eax,[edi,eax*4]
	lea	eax,[edx,eax*8]
	mov	ecx,DWORD PTR last
	mov	edx,eax
	sub	edx,ecx
	jge	$L44
	sub	ecx,eax
	cmp	ecx,1073741824
	jb	$L43
	jmp	$L44
	ALIGN	8
$L50:
	lea	eax,-116[ebp]
	mov	DWORD PTR [esp],eax
	call	ftime
	mov	edi,DWORD PTR -116[ebp]
	mov	ebx,edi
	shl	ebx,4
	xor	edx,edx
	mov	dx,WORD PTR -112[ebp]
	sub	ebx,edi
	mov	eax,edx
	shl	eax,5
	lea	ebx,[edi,ebx*4]
	shl	ebx,5
	sub	eax,edx
	lea	eax,[edx,eax*4]
	add	ebx,edi
	lea	edx,[edi,ebx*8]
	shl	edx,6
	mov	ecx,DWORD PTR last
	lea	eax,[edx,eax*8]
	mov	edx,eax
	sub	edx,ecx
	jge	$L49
	sub	ecx,eax
	cmp	ecx,1073741824
	jae	$L49
	lea	eax,-116[ebp]
	mov	DWORD PTR [esp],eax
	call	ftime
	mov	edi,DWORD PTR -116[ebp]
	mov	eax,edi
	shl	eax,4
	xor	edx,edx
	mov	dx,WORD PTR -112[ebp]
	sub	eax,edi
	mov	ebx,edx
	shl	ebx,5
	lea	eax,[edi,eax*4]
	shl	eax,5
	sub	ebx,edx
	add	eax,edi
	lea	eax,[edi,eax*8]
	shl	eax,6
	lea	edx,[edx,ebx*4]
	lea	eax,[eax,edx*8]
	mov	ecx,DWORD PTR last
	mov	edx,eax
	sub	edx,ecx
	jge	$L49
	sub	ecx,eax
	cmp	ecx,1073741824
	jae	$L49
	lea	eax,-116[ebp]
	mov	DWORD PTR [esp],eax
	call	ftime
	mov	edi,DWORD PTR -116[ebp]
	mov	ebx,edi
	shl	ebx,4
	xor	edx,edx
	mov	dx,WORD PTR -112[ebp]
	sub	ebx,edi
	mov	eax,edx
	shl	eax,5
	lea	ebx,[edi,ebx*4]
	shl	ebx,5
	sub	eax,edx
	lea	eax,[edx,eax*4]
	add	ebx,edi
	lea	edx,[edi,ebx*8]
	shl	edx,6
	mov	ecx,DWORD PTR last
	lea	eax,[edx,eax*8]
	mov	edx,eax
	sub	edx,ecx
	jge	$L49
	sub	ecx,eax
	cmp	ecx,1073741824
	jb	$L48
	jmp	$L49
	ALIGN	8
$L42:
	mov	eax,DWORD PTR -56[ebp]
	dec	eax
	mov	DWORD PTR -40[ebp],eax
	mov	eax,DWORD PTR -56[ebp]
	mov	ebx,DWORD PTR -40[ebp]
	sub	eax,-2147483648
	mov	DWORD PTR -4[ebp],eax
	fild	DWORD PTR -4[ebp]
	and	ebx,ebx
	fadd	DWORD PTR $L011
	fstp	QWORD PTR -28[ebp]
	jl	$L51
	mov	edi,ebx
	cmp	edi,4
	jl	$L52
$L53:
	mov	eax,DWORD PTR -44[ebp]
	mov	DWORD PTR [esp],eax
	mov	DWORD PTR 4[esp],esi
	call	sieve@qpucul$v
	mov	eax,DWORD PTR -44[ebp]
	mov	DWORD PTR [esp],eax
	mov	DWORD PTR 4[esp],esi
	call	sieve@qpucul$v
	mov	eax,DWORD PTR -44[ebp]
	mov	DWORD PTR [esp],eax
	mov	DWORD PTR 4[esp],esi
	call	sieve@qpucul$v
	mov	eax,DWORD PTR -44[ebp]
	mov	DWORD PTR [esp],eax
	mov	DWORD PTR 4[esp],esi
	call	sieve@qpucul$v
	add	edi,-4
	add	ebx,-4
	cmp	edi,4
	jge	$L53
	mov	ebx,edi
$L52:
	mov	eax,DWORD PTR -44[ebp]
	mov	DWORD PTR [esp],eax
	mov	DWORD PTR 4[esp],esi
	call	sieve@qpucul$v
	dec	ebx
	jge	$L52
$L51:
	lea	eax,-104[ebp]
	mov	DWORD PTR [esp],eax
	call	ftime
	mov	edx,DWORD PTR -104[ebp]
	mov	ebx,edx
	shl	ebx,4
	xor	edi,edi
	mov	di,WORD PTR -100[ebp]
	sub	ebx,edx
	mov	eax,edi
	shl	eax,5
	lea	ebx,[edx,ebx*4]
	shl	ebx,5
	sub	eax,edi
	add	ebx,edx
	lea	edx,[edx,ebx*8]
	shl	edx,6
	lea	eax,[edi,eax*4]
	lea	eax,[edx,eax*8]
	mov	ecx,DWORD PTR last
	mov	edx,eax
	sub	edx,ecx
	jge	$L54
	sub	ecx,eax
	cmp	ecx,1073741824
	jb	$L55
$L54:
	mov	DWORD PTR -48[ebp],eax
	mov	ebx,DWORD PTR -40[ebp]
	mov	DWORD PTR last,eax
	and	ebx,ebx
	jl	$L56
	mov	edi,ebx
	cmp	edi,4
	jl	$L57
$L58:
	mov	eax,DWORD PTR -44[ebp]
	mov	DWORD PTR [esp],eax
	mov	DWORD PTR 4[esp],esi
	call	fast_sieve@qpucul$v
	mov	eax,DWORD PTR -44[ebp]
	mov	DWORD PTR [esp],eax
	mov	DWORD PTR 4[esp],esi
	call	fast_sieve@qpucul$v
	mov	eax,DWORD PTR -44[ebp]
	mov	DWORD PTR [esp],eax
	mov	DWORD PTR 4[esp],esi
	call	fast_sieve@qpucul$v
	mov	eax,DWORD PTR -44[ebp]
	mov	DWORD PTR [esp],eax
	mov	DWORD PTR 4[esp],esi
	call	fast_sieve@qpucul$v
	add	edi,-4
	add	ebx,-4
	cmp	edi,4
	jge	$L58
	mov	ebx,edi
$L57:
	mov	eax,DWORD PTR -44[ebp]
	mov	DWORD PTR [esp],eax
	mov	DWORD PTR 4[esp],esi
	call	fast_sieve@qpucul$v
	dec	ebx
	jge	$L57
$L56:
	lea	eax,-92[ebp]
	mov	DWORD PTR [esp],eax
	call	ftime
	mov	edi,DWORD PTR -92[ebp]
	mov	eax,edi
	shl	eax,4
	xor	edx,edx
	mov	dx,WORD PTR -88[ebp]
	sub	eax,edi
	mov	ebx,edx
	shl	ebx,5
	lea	eax,[edi,eax*4]
	shl	eax,5
	sub	ebx,edx
	add	eax,edi
	lea	eax,[edi,eax*8]
	shl	eax,6
	lea	edx,[edx,ebx*4]
	lea	edx,[eax,edx*8]
	mov	ecx,DWORD PTR last
	mov	eax,edx
	sub	eax,ecx
	jge	$L59
	sub	ecx,edx
	cmp	ecx,1073741824
	jb	$L60
$L59:
	mov	eax,DWORD PTR -48[ebp]
	sub	eax,DWORD PTR -64[ebp]
	fld	QWORD PTR -12[ebp]
	sub	eax,-2147483648
	mov	DWORD PTR -4[ebp],eax
	fild	DWORD PTR -4[ebp]
	mov	ecx,edx
	fadd	DWORD PTR $L011
	fdiv	QWORD PTR -28[ebp]
	mov	DWORD PTR last,edx
	fcom	st(1)
	fstsw	ax
	sahf	
	jbe	$L61
$L62:
	fstp	st(0)
	sub	ecx,DWORD PTR -48[ebp]
	mov	DWORD PTR -4[ebp],ecx
	fild	DWORD PTR -4[ebp]
	xchg	eax,eax
	fdiv	QWORD PTR -28[ebp]
	fld	QWORD PTR -36[ebp]
	fxch	st(2)
	fstp	QWORD PTR -12[ebp]
	fcom	st(1)
	fstsw	ax
	sahf	
	jbe	$L63
$L64:
	dec	DWORD PTR -68[ebp]
	fstp	st(0)
	fstp	QWORD PTR -36[ebp]
	cmp	DWORD PTR -68[ebp],0
	jge	$L39
	mov	eax,DWORD PTR -44[ebp]
	mov	DWORD PTR [esp],eax
	mov	DWORD PTR 4[esp],esi
	call	ct_sieve@qpucul$ul
	mov	DWORD PTR [esp],OFFSET DGROUP:$L08
	mov	DWORD PTR 4[esp],esi
	fld	QWORD PTR -12[ebp]
	xchg	eax,eax
	fstp	QWORD PTR 8[esp]
	fld	QWORD PTR -36[ebp]
	fstp	QWORD PTR 16[esp]
	xchg	eax,eax
	mov	DWORD PTR 24[esp],eax
	call	printf
	mov	DWORD PTR [esp],OFFSET DGROUP:_iob+20
	call	fflush
	mov	eax,esi
	mov	DWORD PTR [esp],OFFSET DGROUP:_iob+40
	sub	eax,-2147483648
	mov	DWORD PTR -4[ebp],eax
	fild	DWORD PTR -4[ebp]
	fadd	DWORD PTR $L011
	xchg	eax,eax
	mov	DWORD PTR 4[esp],OFFSET DGROUP:$L09
	fmul	QWORD PTR $L013
	mov	DWORD PTR 8[esp],esi
	xchg	eax,eax
	mov	eax,DWORD PTR 8[ebp]
	mov	DWORD PTR 12[esp],eax
	mov	eax,DWORD PTR -56[ebp]
	xchg	eax,eax
	mov	DWORD PTR 24[esp],eax
	fdiv	QWORD PTR -20[ebp]
	fstp	QWORD PTR 16[esp]
	call	fprintf
	mov	DWORD PTR [esp],OFFSET DGROUP:_iob+40
	call	fflush
	lea	eax,[esi,esi*4]
	lea	eax,[esi,eax*2]
	lea	ecx,1[esi]
	sub	edx,edx
	mov	esi,10
	div	esi
	cmp	ecx,eax
	jl	$L65
	mov	eax,ecx
$L65:
	mov	esi,eax
	cmp	esi,DWORD PTR 8[ebp]
	jbe	$L38
$L37:
	mov	DWORD PTR [esp],OFFSET DGROUP:_iob+40
	mov	DWORD PTR 4[esp],OFFSET DGROUP:$L010
	call	fprintf
	mov	DWORD PTR [esp],OFFSET DGROUP:_iob+40
	call	fflush
	mov	eax,DWORD PTR -44[ebp]
	mov	DWORD PTR [esp],eax
	call	free
	mov	esp,ebp
	mov	ebx,DWORD PTR -176[ebp]
	mov	esi,DWORD PTR -172[ebp]
	mov	edi,DWORD PTR -168[ebp]
	pop	ebp
	ret	
	ALIGN	8
$L55:
	lea	eax,-104[ebp]
	mov	DWORD PTR [esp],eax
	call	ftime
	mov	edx,DWORD PTR -104[ebp]
	mov	eax,edx
	shl	eax,4
	xor	edi,edi
	mov	di,WORD PTR -100[ebp]
	sub	eax,edx
	mov	ebx,edi
	shl	ebx,5
	lea	eax,[edx,eax*4]
	shl	eax,5
	sub	ebx,edi
	add	eax,edx
	lea	eax,[edx,eax*8]
	shl	eax,6
	lea	edi,[edi,ebx*4]
	lea	eax,[eax,edi*8]
	mov	ecx,DWORD PTR last
	mov	edx,eax
	sub	edx,ecx
	jge	$L54
	sub	ecx,eax
	cmp	ecx,1073741824
	jae	$L54
	lea	eax,-104[ebp]
	mov	DWORD PTR [esp],eax
	call	ftime
	mov	edx,DWORD PTR -104[ebp]
	mov	eax,edx
	shl	eax,4
	xor	edi,edi
	mov	di,WORD PTR -100[ebp]
	sub	eax,edx
	mov	ebx,edi
	shl	ebx,5
	lea	eax,[edx,eax*4]
	shl	eax,5
	sub	ebx,edi
	add	eax,edx
	lea	eax,[edx,eax*8]
	shl	eax,6
	lea	edi,[edi,ebx*4]
	lea	eax,[eax,edi*8]
	mov	ecx,DWORD PTR last
	mov	edx,eax
	sub	edx,ecx
	jge	$L54
	sub	ecx,eax
	cmp	ecx,1073741824
	jae	$L54
	lea	eax,-104[ebp]
	mov	DWORD PTR [esp],eax
	call	ftime
	mov	edx,DWORD PTR -104[ebp]
	mov	eax,edx
	shl	eax,4
	xor	edi,edi
	mov	di,WORD PTR -100[ebp]
	sub	eax,edx
	mov	ebx,edi
	shl	ebx,5
	lea	eax,[edx,eax*4]
	shl	eax,5
	sub	ebx,edi
	add	eax,edx
	lea	eax,[edx,eax*8]
	shl	eax,6
	lea	edi,[edi,ebx*4]
	lea	eax,[eax,edi*8]
	mov	ecx,DWORD PTR last
	mov	edx,eax
	sub	edx,ecx
	jge	$L54
	sub	ecx,eax
	cmp	ecx,1073741824
	jb	$L51
	jmp	$L54
	ALIGN	8
$L60:
	lea	eax,-92[ebp]
	mov	DWORD PTR [esp],eax
	call	ftime
	mov	edx,DWORD PTR -92[ebp]
	mov	ebx,edx
	shl	ebx,4
	xor	edi,edi
	mov	di,WORD PTR -88[ebp]
	sub	ebx,edx
	mov	eax,edi
	shl	eax,5
	lea	ebx,[edx,ebx*4]
	shl	ebx,5
	sub	eax,edi
	add	ebx,edx
	lea	edx,[edx,ebx*8]
	shl	edx,6
	lea	eax,[edi,eax*4]
	lea	edx,[edx,eax*8]
	mov	ecx,DWORD PTR last
	mov	eax,edx
	sub	eax,ecx
	jge	$L59
	sub	ecx,edx
	cmp	ecx,1073741824
	jae	$L59
	lea	eax,-92[ebp]
	mov	DWORD PTR [esp],eax
	call	ftime
	mov	edi,DWORD PTR -92[ebp]
	mov	ebx,edi
	shl	ebx,4
	xor	edx,edx
	mov	dx,WORD PTR -88[ebp]
	sub	ebx,edi
	mov	eax,edx
	shl	eax,5
	lea	ebx,[edi,ebx*4]
	shl	ebx,5
	sub	eax,edx
	lea	eax,[edx,eax*4]
	add	ebx,edi
	lea	edx,[edi,ebx*8]
	shl	edx,6
	mov	ecx,DWORD PTR last
	lea	edx,[edx,eax*8]
	mov	eax,edx
	sub	eax,ecx
	jge	$L59
	sub	ecx,edx
	cmp	ecx,1073741824
	jae	$L59
	lea	eax,-92[ebp]
	mov	DWORD PTR [esp],eax
	call	ftime
	mov	edx,DWORD PTR -92[ebp]
	mov	ebx,edx
	shl	ebx,4
	xor	edi,edi
	mov	di,WORD PTR -88[ebp]
	sub	ebx,edx
	mov	eax,edi
	shl	eax,5
	lea	ebx,[edx,ebx*4]
	shl	ebx,5
	sub	eax,edi
	add	ebx,edx
	lea	edx,[edx,ebx*8]
	shl	edx,6
	lea	eax,[edi,eax*4]
	lea	edx,[edx,eax*8]
	mov	ecx,DWORD PTR last
	mov	eax,edx
	sub	eax,ecx
	jge	$L59
	sub	ecx,edx
	cmp	ecx,1073741824
	jb	$L56
	jmp	$L59
	ALIGN	8
$L61:
	fxch	st(1)
	jmp	$L62
	ALIGN	8
$L63:
	fxch	st(1)
	jmp	$L64
	ALIGN	8
measure@qui$v	ENDP

;====================
; main
;--------------------
	ALIGN	8
	PUBLIC	main
main	proc	near
	push	ebp
	mov	ebp,esp
	sub	esp,8
	mov	ecx,DWORD PTR 12[ebp]
	add	ecx,4
	mov	eax,268435456
	mov	ecx,DWORD PTR [ecx]
	and	ecx,ecx
	je	$L66
	mov	DWORD PTR [esp],ecx
	call	atoi
	shl	eax,10
$L66:
	mov	DWORD PTR [esp],eax
	call	measure@qui$v
	mov	esp,ebp
	sub	eax,eax
	pop	ebp
	ret	
	ALIGN	8
main	ENDP
	EXTRN	printf:NEAR
	EXTRN	malloc:NEAR
	EXTRN	_iob:NEAR
	EXTRN	fprintf:NEAR
	EXTRN	ftime:NEAR
	EXTRN	fflush:NEAR
	EXTRN	free:NEAR
	EXTRN	atoi:NEAR
_TEXT	ENDS
	EXTRN	_mwfltused
	EXTRN	_mw87_used
	EXTRN	_mwargstack
	EXTRN	_mwgoc
	END
