
# 68000 implementation


	
	.globl _fast_sieve

	.text
	.even

_fast_sieve:

	moveml 	#0x7ffe, sp@-	| save all but A7 and D0 (56 bytes)
	movel 	sp@(60), a4
	movel 	sp@(64), d0
	movel 	d0, d7
	lsll 	#3, d7
	lea 	a4@(0,d0:l), a2	| a2=b, a4=a, d0=n, d7=N

	movel	d0, sp@-
	pea	85:w
	movel	a4, sp@-
	jbsr 	_memset
	lea	sp@(12), sp	| fill(a, u8(0x55), n);

	moveb	#83, a4@	| a[0]=0x53;
	
	moveq	#2, d6		| d6=k
	moveq	#4, d5		| d5=kk
	moveq	#7, d3		| d3=#7

outer_loop:
		
	addl	d6, d5
	addl	d6, d5
	addql	#1, d5		| kk+=2*k+1 
	addql	#1, d6		| k++

	cmpl	d5, d7
	jls	finished
	
	movel	d6, d4     
	asrl	#3, d4
	movel	d6, d1
	andl	d3, d1
	btst	d1, a4@(d4:l)
	bne	outer_loop	| if(a[k>>3]&(1<<(k&7))) continue;

	movel	d6, d0
	addl	d6, d0
	subl 	d7, d0		| i=2*k-N

	.even	| d0=i, d1=i&7, d3=7, d4=i>>3, d5=kk, d6=k, d7=N, a2=b, a4=a

inner_loop:			| tohle by na A600 chipRAM-PAL 7.09 MHz melo vyjit na 66.7 taktu na iteraci
	movel	d0, d4		| 4
	asrl	#3, d4		|14=8+6	| d4=d0>>3
	movel	d0, d1		| 4
	andl	d3, d1		| 8	| d1=d0&7
	bset	d1, a2@(d4:l)	|14=8+6
	addl	d6, d0		| 8
	bpl 	outer_loop	| 8   ________ 60
				
	movel	d0, d4		| 4
	asrl	#3, d4		|14=8+6	| d4=d0>>3
	movel	d0, d1		| 4
	andl	d3, d1		| 8	| d1=d0&7
	bset	d1, a2@(d4:l)	|14=8+6
	addl	d6, d0		| 8
	bmi	inner_loop	|10   ________ 62
	bra	outer_loop
				
finished:
	moveml sp@+, #0x7ffe
	rts


